/*
* ============================================================================
*  Name        : tcodecsettings.h
*  Part of     : mccexample / mccexengine
*  Description : TCodecSettings class definition
*  Version     : %version: %
*
*  Copyright  2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.2
*/

#ifndef T_TCODECSETTINGS_H
#define T_TCODECSETTINGS_H

#include <e32cmn.h>
#include <mmcccodecinformation.h>

/**
 * Simple T - style class to pass codec related parameters in the MCC example
 * between example application and engine.
 */
class TCodecSettings
    {
public:
    
    /**
     * C++ default constructor.
     */
    TCodecSettings()
        {   };
    
public: // Data
    
    /**
     * PTime value to be used for the codec.
     */
    TInt iPTime;
    
    /**
     * Max PTime value to be used for the codec.
     */
    TInt iMaxPTime;
    
    /**
     * Flag to indicate whether or not VAD/CN should be enabled.
     */
    TBool iVadCn;
    
    /**
     * Suggested jitterbuffer size.
     */
    TInt iJitterBufferSize;
    
    /**
     * Name of the codec. Must match to those defined MCC codec API.
     * @see mmcccodecinformation.h
     */
    TBuf8<KMaxSdpNameLength> iCodecName;
    
    };

#endif  // T_TCODECSETTINGS_H
