/*
* ============================================================================
*  Name        : mccexappmainview.h
*  Part of     : mccexample / mccexapp
*  Description : CMccExAppMainView declaration
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.2
*/

#ifndef C_CMCCEXAPPMAINVIEW_H
#define C_CMCCEXAPPMAINVIEW_H

#include "mccexappviewbase.h"

class CMccExEngine;

/**
 * CMccExAppMainView provides the main view of the application.
 */
class CMccExAppMainView : public CMccExAppViewBase
    {
public:
// Constructors and destructor

    /**
     * Destructor.
     */
    virtual ~CMccExAppMainView();

    /**
     * Two-phased constructor.
     * 
     * @param aEngine Reference to the engine.
     */
    static CMccExAppMainView* NewL( CMccExEngine& aEngine );

    /**
     * Two-phased constructor. Leaves the created instance into the cleanup
     * stack.
     * 
     * @param aEngine Reference to the engine.
     */
    static CMccExAppMainView* NewLC( CMccExEngine& aEngine );

// From CAknView
    
    /**
     * From CAknView.
     * Handles the menu commands for this view.
     * 
     * @see CAknView
     */
    void HandleCommandL( TInt aCommand );
    
protected:
    
// From CMccExAppViewBase
    
    /**
     * From CMccExAppViewBase.
     * Factory method for creating the compound control of this view. Every
     * deriving class must implement this function.
     * 
     * @see CMccExAppViewBase
     * @return CCoeControl Newly created compound control.
    */
    CCoeControl* CreateContainerL();
    
private:
    
    /**
     * Constructor for performing 1st stage construction.
     * 
     * @param aEngine Reference to the engine.
     */
    CMccExAppMainView( CMccExEngine& aEngine );
    
    };

#endif // C_CMCCEXAPPMAINVIEW_H
