/*
* ============================================================================
*  Name        : mccexappnwsettings.cpp
*  Part of     : mccexample / mccexapp
*  Description : CMccExAppNwSettings class implementation
*  Version     : %version: %
*
*  Copyright  2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.1.1
*/


#include <e32base.h>

#include "mccexappnwsettings.h"

const TInt KDefaultRtpPort = 5000;
const TInt KDefaultMediaQos = 46;

// ======== MEMBER FUNCTIONS ========

// ---------------------------------------------------------------------------
// CMccExAppNwSettings::CMccExAppNwSettings
// ---------------------------------------------------------------------------
//
CMccExAppNwSettings::CMccExAppNwSettings()
    {
    TInetAddr ipAddress = TInetAddr( INET_ADDR( 127, 0, 0, 1 ), 0 );
    SetRemoteAddress( ipAddress );
    SetRtpPort( KDefaultRtpPort );
    SetRtcpStatus( ETrue );
    SetMediaQoS( KDefaultMediaQos );
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::~CMccExAppNwSettings
// ---------------------------------------------------------------------------
//
CMccExAppNwSettings::~CMccExAppNwSettings()
    {
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::NewL
// ---------------------------------------------------------------------------
//
CMccExAppNwSettings* CMccExAppNwSettings::NewL()
    {
    return  new ( ELeave ) CMccExAppNwSettings;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::RemoteAddress
// ---------------------------------------------------------------------------
//
TInetAddr& CMccExAppNwSettings::RemoteAddress()
    {
    return iRemoteAddress;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::RtpPort
// ---------------------------------------------------------------------------
//
TInt& CMccExAppNwSettings::RtpPort()
    {
    return iRtpPort;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::RtcpStatus
// ---------------------------------------------------------------------------
//
TBool& CMccExAppNwSettings::RtcpStatus()
    {
    return iRtcpStatus;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::MediaQoS
// ---------------------------------------------------------------------------
//
TInt& CMccExAppNwSettings::MediaQoS()
    {
    return iMediaQoS;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::SetRemoteAddress
// ---------------------------------------------------------------------------
//
void CMccExAppNwSettings::SetRemoteAddress( const TInetAddr& aAddress )
    {
    iRemoteAddress = aAddress;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::SetRtpPort
// ---------------------------------------------------------------------------
//
void CMccExAppNwSettings::SetRtpPort( const TInt& aPort )
    {
    iRtpPort = aPort;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::SetRtcpStatus
// ---------------------------------------------------------------------------
//
void CMccExAppNwSettings::SetRtcpStatus( const TBool& aRtcpStatus )
    {
    iRtcpStatus = aRtcpStatus;
    }


// ---------------------------------------------------------------------------
// CMccExAppNwSettings::SetMediaQoS
// ---------------------------------------------------------------------------
//
void CMccExAppNwSettings::SetMediaQoS( const TInt& aMediaQoS )
    {
    iMediaQoS = aMediaQoS;
    }
