/*
* ============================================================================
*  Name        : uplinkvideostream.cpp
*  Part of     : mccexample / mccexengine
*  Description : CUplinkVideoStream class implementation
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.1.1
*/

#include <mmccinterfacedef.h>
#include <mmccinterface.h>

#include "uplinkvideostream.h"

// ======== MEMBER FUNCTIONS ========

// ---------------------------------------------------------------------------
// CUplinkVideoStream::CUplinkVideoStream
// ---------------------------------------------------------------------------
//
CUplinkVideoStream::CUplinkVideoStream(
    CStreamStateMachine& aStateMachine,
    CMccInterface& aMcc,
    TUint32 aSession,
    TUint32 aLink,
    const TSize& aSize,
    TInt aCameraIndex ) : 
    CVideoStreamBase( aStateMachine, aMcc, aSession, aLink ),
    iCameraIndex( aCameraIndex ), iSize( aSize )
    {
    }


// ---------------------------------------------------------------------------
// CUplinkVideoStream::~CUplinkVideoStream
// ---------------------------------------------------------------------------
//
CUplinkVideoStream::~CUplinkVideoStream()
    {
    }


// ---------------------------------------------------------------------------
// CUplinkVideoStream::NewLC
// ---------------------------------------------------------------------------
//
CUplinkVideoStream* CUplinkVideoStream::NewLC(
    CStreamStateMachine& aStateMachine,
    CMccCodecInformation& aCodec,
    CMccInterface& aMcc,
    TUint32 aSession,
    TUint32 aLink,
    const TSize& aSize,
    TInt aCameraIndex )
    {
    CUplinkVideoStream* self = new ( ELeave ) CUplinkVideoStream( 
            aStateMachine, aMcc, aSession,
            aLink, aSize, aCameraIndex );
    
    CleanupStack::PushL( self );
    self->ConstructL( aCodec, KMccVideoUplinkStream );
    return self;
    }


// ---------------------------------------------------------------------------
// CUplinkVideoStream::NewL
// ---------------------------------------------------------------------------
//
CUplinkVideoStream* CUplinkVideoStream::NewL( 
    CStreamStateMachine& aStateMachine,
    CMccCodecInformation& aCodec,
    CMccInterface& aMcc,
    TUint32 aSession,
    TUint32 aLink,
    const TSize& aSize,
    TInt aCameraIndex )
    {
    CUplinkVideoStream* self = CUplinkVideoStream::NewLC( aStateMachine,
            aCodec, aMcc, aSession,
            aLink, aSize, aCameraIndex );
    
    CleanupStack::Pop( self );
    return self;
    }


// ---------------------------------------------------------------------------
// CUplinkVideoStream::CreateStreamL
// ---------------------------------------------------------------------------
//
void CUplinkVideoStream::CreateStreamL()
    {
    TMccVideoSourceSetting settings;
    settings.iAudioPayloadType = KAudioPayloadType;
    settings.iVideoPayloadType = KVideoPayloadType;
    settings.iDeviceIndex = iCameraIndex;
    settings.iSize = iSize;
    
    TMccVideoSourceSettingBuf buffer( settings );
    
    AddSinkL( KUidMccRtpSink, KNullDesC8 );
    AddSourceL( KUidMccVideoSource, buffer );
    CStreamBase::CreateStreamL();
    }

