/*
* ============================================================================
*  Name        : videostreambase.cpp
*  Part of     : mccexample / mccexengine
*  Description : CVideoStreamBase class implementation
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.1.1
*/

#include <mmcccodecinformation.h>
#include <mmccinterfacedef.h>
#include <mmccinterface.h>

#include "videostreambase.h"

// ======== MEMBER FUNCTIONS ========

// ---------------------------------------------------------------------------
// CVideoStreamBase::CVideoStreamBase
// ---------------------------------------------------------------------------
//
CVideoStreamBase::CVideoStreamBase( CStreamStateMachine& aStateMachine,
    CMccInterface& aMcc, TUint32 aSession, TUint32 aLink  ) : 
    CStreamBase( aStateMachine, aMcc, aSession, aLink )
    {
    }


// ---------------------------------------------------------------------------
// CVideoStreamBase::~CVideoStreamBase
// ---------------------------------------------------------------------------
//
CVideoStreamBase::~CVideoStreamBase()
    {
    }


// ---------------------------------------------------------------------------
// CVideoStreamBase::ConstructL
// ---------------------------------------------------------------------------
//
void CVideoStreamBase::ConstructL( CMccCodecInformation& aCodec, TInt aType )
    {
    // Assert that the arguments are proper for a video stream.
    __ASSERT_ALWAYS(
        KMccVideoDownlinkStream == aType || KMccVideoUplinkStream == aType,
        User::Leave( KErrArgument ) );
    __ASSERT_ALWAYS( KUidMediaTypeVideo == aCodec.Type(),
        User::Leave( KErrArgument ) );
    
    CStreamBase::ConstructL( aCodec, aType );
    
    // Copy the video parameters by hand
    CMccCodecInformation& codec( Codec() );
    User::LeaveIfError( codec.SetFrameHeight( aCodec.FrameHeight() ) );
    User::LeaveIfError( codec.SetFrameWidth( aCodec.FrameWidth() ) );
    User::LeaveIfError( codec.SetFramerate( aCodec.Framerate() ) );
    }
